USE Concurrency2

BEGIN TRAN 

;WITH cte AS (
    SELECT TOP(1) QueueID, Payload
      FROM dbo.QueueTable WITH (ROWLOCK, READPAST)
    ORDER BY QueueID)
  DELETE FROM cte
    OUTPUT deleted.QueueID, deleted.Payload

-- This is where we do our processing on this row
WAITFOR DELAY '00:00:10';

COMMIT TRAN 

SELECT * FROM dbo.QueueTable

